package com.sun.corba.se.spi.servicecontext;

import java.util.Enumeration;
import org.omg.CORBA.BAD_PARAM;
import com.sun.corba.se.impl.orbutil.ORBUtility;
import java.util.Vector;
import com.sun.corba.se.spi.orb.ORB;

public class ServiceContextRegistry
{
    private ORB orb;
    private Vector scCollection;
    
    private void dprint(String s) {
        ORBUtility.dprint(this, s);
    }
    
    public ServiceContextRegistry(ORB orb) {
        this.scCollection = new Vector();
        this.orb = orb;
    }
    
    public void register(Class obj) {
        if (ORB.ORBInitDebug) {
            this.dprint("Registering service context class " + obj);
        }
        ServiceContextData obj2 = new ServiceContextData(obj);
        if (this.findServiceContextData(obj2.getId()) == null) {
            this.scCollection.addElement(obj2);
            return;
        }
        throw new BAD_PARAM("Tried to register duplicate service context");
    }
    
    public ServiceContextData findServiceContextData(int i) {
        if (ORB.ORBInitDebug) {
            this.dprint("Searching registry for service context id " + i);
        }
        Enumeration<Object> elements = this.scCollection.elements();
        while (elements.hasMoreElements()) {
            ServiceContextData obj = (ServiceContextData)(ServiceContextData)elements.nextElement();
            if (obj.getId() == i) {
                if (ORB.ORBInitDebug) {
                    this.dprint("Service context data found: " + obj);
                    return obj;
                }
                return obj;
            }
            else {
                continue;
            }
        }
        if (ORB.ORBInitDebug) {
            this.dprint("Service context data not found");
        }
        return null;
    }
}
